/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationMessageDataMediaInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessageDataMediaInner{}

// ConversationMessageDataMediaInner struct for ConversationMessageDataMediaInner
type ConversationMessageDataMediaInner struct {
	Id string `json:"id"`
	Object *string `json:"object,omitempty"`
	Url *string `json:"url,omitempty"`
	MimeType string `json:"mime_type"`
	FileName *string `json:"file_name,omitempty"`
	Width *int32 `json:"width,omitempty"`
	Height *int32 `json:"height,omitempty"`
	CardIdx *int32 `json:"card_idx,omitempty"`
	Status *string `json:"status,omitempty"`
}

// NewConversationMessageDataMediaInner instantiates a new ConversationMessageDataMediaInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessageDataMediaInner(id string, mimeType string) *ConversationMessageDataMediaInner {
	this := ConversationMessageDataMediaInner{}
	this.Id = id
	this.MimeType = mimeType
	return &this
}

// NewConversationMessageDataMediaInnerWithDefaults instantiates a new ConversationMessageDataMediaInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessageDataMediaInnerWithDefaults() *ConversationMessageDataMediaInner {
	this := ConversationMessageDataMediaInner{}
	return &this
}

// GetId returns the Id field value
func (o *ConversationMessageDataMediaInner) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ConversationMessageDataMediaInner) SetId(v string) {
	o.Id = v
}

// GetObject returns the Object field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetObject() string {
	if o == nil || IsNil(o.Object) {
		var ret string
		return ret
	}
	return *o.Object
}

// GetObjectOk returns a tuple with the Object field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetObjectOk() (*string, bool) {
	if o == nil || IsNil(o.Object) {
		return nil, false
	}
	return o.Object, true
}

// HasObject returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasObject() bool {
	if o != nil && !IsNil(o.Object) {
		return true
	}

	return false
}

// SetObject gets a reference to the given string and assigns it to the Object field.
func (o *ConversationMessageDataMediaInner) SetObject(v string) {
	o.Object = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *ConversationMessageDataMediaInner) SetUrl(v string) {
	o.Url = &v
}

// GetMimeType returns the MimeType field value
func (o *ConversationMessageDataMediaInner) GetMimeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetMimeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MimeType, true
}

// SetMimeType sets field value
func (o *ConversationMessageDataMediaInner) SetMimeType(v string) {
	o.MimeType = v
}

// GetFileName returns the FileName field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetFileName() string {
	if o == nil || IsNil(o.FileName) {
		var ret string
		return ret
	}
	return *o.FileName
}

// GetFileNameOk returns a tuple with the FileName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetFileNameOk() (*string, bool) {
	if o == nil || IsNil(o.FileName) {
		return nil, false
	}
	return o.FileName, true
}

// HasFileName returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasFileName() bool {
	if o != nil && !IsNil(o.FileName) {
		return true
	}

	return false
}

// SetFileName gets a reference to the given string and assigns it to the FileName field.
func (o *ConversationMessageDataMediaInner) SetFileName(v string) {
	o.FileName = &v
}

// GetWidth returns the Width field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetWidth() int32 {
	if o == nil || IsNil(o.Width) {
		var ret int32
		return ret
	}
	return *o.Width
}

// GetWidthOk returns a tuple with the Width field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetWidthOk() (*int32, bool) {
	if o == nil || IsNil(o.Width) {
		return nil, false
	}
	return o.Width, true
}

// HasWidth returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasWidth() bool {
	if o != nil && !IsNil(o.Width) {
		return true
	}

	return false
}

// SetWidth gets a reference to the given int32 and assigns it to the Width field.
func (o *ConversationMessageDataMediaInner) SetWidth(v int32) {
	o.Width = &v
}

// GetHeight returns the Height field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetHeight() int32 {
	if o == nil || IsNil(o.Height) {
		var ret int32
		return ret
	}
	return *o.Height
}

// GetHeightOk returns a tuple with the Height field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetHeightOk() (*int32, bool) {
	if o == nil || IsNil(o.Height) {
		return nil, false
	}
	return o.Height, true
}

// HasHeight returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasHeight() bool {
	if o != nil && !IsNil(o.Height) {
		return true
	}

	return false
}

// SetHeight gets a reference to the given int32 and assigns it to the Height field.
func (o *ConversationMessageDataMediaInner) SetHeight(v int32) {
	o.Height = &v
}

// GetCardIdx returns the CardIdx field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetCardIdx() int32 {
	if o == nil || IsNil(o.CardIdx) {
		var ret int32
		return ret
	}
	return *o.CardIdx
}

// GetCardIdxOk returns a tuple with the CardIdx field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetCardIdxOk() (*int32, bool) {
	if o == nil || IsNil(o.CardIdx) {
		return nil, false
	}
	return o.CardIdx, true
}

// HasCardIdx returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasCardIdx() bool {
	if o != nil && !IsNil(o.CardIdx) {
		return true
	}

	return false
}

// SetCardIdx gets a reference to the given int32 and assigns it to the CardIdx field.
func (o *ConversationMessageDataMediaInner) SetCardIdx(v int32) {
	o.CardIdx = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ConversationMessageDataMediaInner) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataMediaInner) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ConversationMessageDataMediaInner) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *ConversationMessageDataMediaInner) SetStatus(v string) {
	o.Status = &v
}

func (o ConversationMessageDataMediaInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessageDataMediaInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.Object) {
		toSerialize["object"] = o.Object
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	toSerialize["mime_type"] = o.MimeType
	if !IsNil(o.FileName) {
		toSerialize["file_name"] = o.FileName
	}
	if !IsNil(o.Width) {
		toSerialize["width"] = o.Width
	}
	if !IsNil(o.Height) {
		toSerialize["height"] = o.Height
	}
	if !IsNil(o.CardIdx) {
		toSerialize["card_idx"] = o.CardIdx
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	return toSerialize, nil
}

type NullableConversationMessageDataMediaInner struct {
	value *ConversationMessageDataMediaInner
	isSet bool
}

func (v NullableConversationMessageDataMediaInner) Get() *ConversationMessageDataMediaInner {
	return v.value
}

func (v *NullableConversationMessageDataMediaInner) Set(val *ConversationMessageDataMediaInner) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessageDataMediaInner) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessageDataMediaInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessageDataMediaInner(val *ConversationMessageDataMediaInner) *NullableConversationMessageDataMediaInner {
	return &NullableConversationMessageDataMediaInner{value: val, isSet: true}
}

func (v NullableConversationMessageDataMediaInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessageDataMediaInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


